function [W,S,U,A,B,C,D,E,F]=ctrlStp2U(A,B,C,D,E,F,M,N,om,la,st)
// [W,S,U,A,B,C,D,E,F]=ctrlStp2U(A,B,C,D,E,F,M,N,om,la,t,st)
//                     dynamic programming with setpoint control
//                     and penalization of increments of u (u_t-u_t-1)
// control  u_t=-W(S'.x_t-1-la.u_t-1+U   in the application part
// A,B,C,D,E,F  - inicialized to zero (as output for IST method)
// om,la          penalizations of (y_t-s_t) and (u_t-u_t-1)
// t              current time

nh=size(st,2);
for i=nh:-1:1
  s=st(:,i);                            // setpoint
  
  R=M'*(A+om)*M;                        // nXn
  S=M'*(A+om)*N+M'*C;                   // nXm
  Wp=N'*A*N+N'*om*N+2*N'*C+B+la;
  if det(Wp)>1e-8
    W=inv(Wp);
  else
    W=1e8*eye(size(la));
  end
  U=N'*D-N'*om*s+E;                     // mX1                 
  V=M'*(D-om*s);                        // nX1
  G=F+s'*om*s;
  A=R-S*W*S';                           // nXn
  B=la-la'*W*la;                        // mXm
  C=S*W*la;                             // nXm
  D=V-S*W*U;                            // nX1
  E=la'*W*U;                            // mX1
  F=G-U'*W*U;                           // 1X1
end
endfunction
