﻿// ini6Dyn.sce
// Inicializace dynamických komponent
// ------------------------------------------
[u,t,n]=file();                         // find working directory
chdir(dirname(n(2)));                   // set working directory
clear("u","t","n")                      // clear auxiliary data
exec("ScIntro.sce",-1),mode(0)          // intro to sesion

// INITIALLIZATION OF ESTIMATION OD DYNAMIC MODEL AS STATIC ONE
function V=th2VN(nps,my);     
  // nps  length of regression vector (without y(t))
  // my   average of y
  my=my(:);
  ny=length(my);
  nPs=ny+nps;
  V=eye(nPs,nPs);
  V(ny,ny)=my*my';
  V(nPs,1:ny)=my';
  V(1:ny,nPs)=my;
endfunction

nd=500;
b0=1; a=.2; b1=-.3; k=2; sd=.1; y(1)=2; y(2)=5;   //simul. parameters
u=1+.2*sin(10*%pi*(1:nd)/nd)+.1*rand(1,nd,'n');   // input
// sinulation
for t=3:nd
  y(t)=b0*u(t)+a*y(t-1)+b1*u(t-1)+k+sd*rand(1,1,'n');
end

my=mean(y);                        // mean of initial output
// Konstruction of V
V0=th2VN(4,my);
V=V0;

// Estimation
for t=3:nd
  Ps=[y(t),u(t),y(t-1),u(t-1),1]';
  V=V+Ps*Ps';
  Vy=V(1,1);
  Vyp=V(2:$,1);
  Vp=V(2:$,2:$);
  th=inv(Vp+1e-12*eye(Vp))*Vyp;

  tht(:,t)=th;                     // evolution of est. parameters
end

set(scf(1),'position',[300 300 500 400])
plot(tht')
title 'Evolution of par.estimates'
disp(th,'Esimated parameters')

// Prediction
for t=3:nd
  yp(t)=th(1)*u(t)+th(2)*y(t-1)+th(3)*u(t-1)+th(4);
end

s=2:nd;
set(scf(2),'position',[800 300 500 400])
plot(s,y(s),s,yp(s))
title 'Prediction'
