﻿// ini7UmVekt.sce
// Umělé regresní vektory
// ------------------------------------------
[u,t,n]=file();                         // find working directory
chdir(dirname(n(2)));                   // set working directory
clear("u","t","n")                      // clear auxiliary data
exec("ScIntro.sce",-1),mode(0)          // intro to sesion
rand('seed',0);

nd=200;        // all data (init + estim)
ni=50;         // initial data
I_init=0;      // I_init=1 - initialization (only)
               // I_init=0 - estimation with constructed initial V

// Simulation
u1=   sign(2*sin(12*%pi*(1:nd)/nd))+1;
u2= 2*sign(2*sin(10*%pi*(151:nd+150)/nd))+2;
u3=.2*sign(2*sin(8*%pi*(1:nd)/nd))+1;

a=.6; k=.5; y(1)=0;
for t=2:nd
  y(t)=a*y(t-1)+u1(t)+u2(t)+u3(t)+k+.5*rand(1,1,'n');
end

// Initialization (external data vectors)
if I_init==1
s=2:ni;
plot([y(s) u1(s)' u2(s)' u3(s)'])
legend('y','u1','u2','u3');
end

Psi=list();
// Psi = [y(t) y(t-1) u1(t) u2(t) u3(t) 1]   // data vector
// th0:         a      b1    b2    b3   k    // corresponding parameters
// extracted from prior data (can be also from expert knowledge)
Psi(1)=[10  9 2 0 1.2 1]';
Psi(2)=[17 15 2 4 1.2 1]';
Psi(3)=[15 16 0 4 1.2 1]';
Psi(4)=[14 14 0 4 .8  1]';
Psi(5)=[10 13 0 0 .8  1]';
Psi(6)=[11 10 2 0 1.2 1]';
Psi(7)=[11 11 2 0 1.2 1]';
Psi(8)=[8 7 2 0 .8 1]';
Psi(9)=[9 8 2 0 .8 1]';
Psi(10)=[9 8 2 0 .8 1]';

m=length(Psi(1));
n=length(Psi);
V=zeros(m,m);
for i=1:n
  V=V+Psi(i)*Psi(i)';
end

th0=v2thN(V/n,1)'
if I_init==1, return, end

// Estimation;
V=V*50;
for t=(ni+1):nd
  Psi=[y(t) y(t-1) u1(t) u2(t) u3(t) 1]';
  V=V+Psi*Psi';
  th=v2thN(V/(t-n),1);
  tht(:,t)=th;
end
th=th'
thSim=[.6 1 1 1 .5]

scf();
plot(tht')
