function [p,Lp]=ExpN(y,d)
  // [p,Lp]=ExpN(y,d)   value of exponential pdf  (1/d)exp(-y/d)

  // p       probability
  // Lp      logarithm of prob.
  // y       realization
  // d       expectation

  y=y(:);           // column vector
  d=d(:);           // column vector

  kL=prod(log(d));
  ex=sum(-y./d);
  Lp=ex-kL;
  p=exp(Lp);
endfunction
