function [py, yp, yr, b]=lrEst(b0,y,x)
// logReg(b,y,x)   prediction for LR with multinomial Y
//
// yp   prediction in probabilities
// yr   prediction in values 0,1 (rounded yp)
// b    estimates of parameter (if performed)
// b    regression coefficients (b=[] - with estimation)
// y    regressand - independent
// x    regressor - dependant
//
if isempty(b0)
  rand('norm')
  opt=optimset("MaxFunEvals",1e8, "MaxIter",1e8);
//  opt.Display='off'; 
//  opt.MaxFunEvals=1e6;
//  opt.MaxIter=1e3;
  b0=1*rand(size(x,2)+1,max(y));
  b0=b0(:);
  //fc=list(lrLikN,y,x);                //  
  //pause
  [b1,v0,ex,op]=fminsearch(list(lrLikN,y,x),b0,opt);
  b=matrix(b1,size(x,2)+1,max(y));
  //pause
  if ex<1, mprintf('\n Wrong exit condition: ex = %i\n',ex), end
else
   b=matrix(b0,size(x,2)+1,max(y));
end

[n m]=size(x);
xp=[ones(n,1) x];
ex=exp(xp*b);
se=sum(ex,2);
dn=(se+1)*ones(1,max(y));
py=ex./dn;
py=[1-sum(py,2) py];
yr=zeros(n,1);
for i=1:n
  [mx ix]=max(py(i,:));
  yr(i)=ix-1;
end
yp=py*[0:size(py,2)-1]';
endfunction
